/* A recursive-descent parser generated by peg 0.1.15 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define YYRULECOUNT 42


#include <glib.h>
#include "parser.h"

#define YY_INPUT(buf, result, max_size)                          \
{                                                                \
    int yyc = (charbuf && *charbuf != '\0') ? *charbuf++ : EOF;  \
    result = (EOF == yyc) ? 0 : (*buf = yyc, 1);                 \
}

static GList *nodes = NULL;
static gint if_count = 0;
static gchar *fn_name = NULL;
static GSList *fn_args = NULL;
static balde_template_fn_arg_type_t fn_arg_type;
static const gchar *charbuf = NULL;
static gboolean clean_whitespace_next = FALSE;

static void
balde_template_clean_whitespace_prev(void)
{
    GList *last = g_list_last(nodes);
    for (GList *tmp = last; tmp != NULL; tmp = g_list_previous(tmp)) {
        balde_template_block_t *block = tmp->data;
        if (block->type == BALDE_TEMPLATE_CONTENT_BLOCK) {
            balde_template_content_block_t *content = block->block;
            g_strchomp(content->content);
            break;
        }
    }
}

static void
balde_template_clean_whitespace_next(void)
{
    clean_whitespace_next = TRUE;
}

static void
balde_template_import_block(const gchar *import)
{
    balde_template_import_block_t *block = g_new(balde_template_import_block_t, 1);
    block->import = g_strdup(import);
    balde_unescape_single_quoted_strings(&(block->import));
    balde_template_block_t *node = g_new(balde_template_block_t, 1);
    node->block = block;
    node->type = BALDE_TEMPLATE_IMPORT_BLOCK;
    nodes = g_list_append(nodes, node);
}

static void
balde_template_include_block(const gchar *include)
{
    balde_template_include_block_t *block = g_new(balde_template_include_block_t, 1);
    block->include = g_strdup(include);
    balde_unescape_single_quoted_strings(&(block->include));
    balde_template_block_t *node = g_new(balde_template_block_t, 1);
    node->block = block;
    node->type = BALDE_TEMPLATE_INCLUDE_BLOCK;
    nodes = g_list_append(nodes, node);
}

static void
balde_template_if_block(const gchar *if_var)
{
    balde_template_if_block_t *block = g_new(balde_template_if_block_t, 1);
    block->if_var = g_strdup(if_var);
    balde_template_block_t *node = g_new(balde_template_block_t, 1);
    node->block = block;
    node->type = BALDE_TEMPLATE_IF_BLOCK;
    nodes = g_list_append(nodes, node);
    if_count++;
}

static void
balde_template_else_block(void)
{
    if (if_count <= 0)
        g_error("Syntax error: {" "%% else %%" "} block without any open {" "%% if ... %%" "} block");
    balde_template_block_t *node = g_new(balde_template_block_t, 1);
    node->block = NULL;
    node->type = BALDE_TEMPLATE_ELSE_BLOCK;
    nodes = g_list_append(nodes, node);
}

static void
balde_template_endif_block(void)
{
    if (if_count-- <= 0)
        g_error("Syntax error: {" "%% endif %%" "} block before any {" "%% if ... %%" "} block");
    balde_template_block_t *node = g_new(balde_template_block_t, 1);
    node->block = NULL;
    node->type = BALDE_TEMPLATE_IF_END_BLOCK;
    nodes = g_list_append(nodes, node);
}

static void
balde_template_content_block(const gchar *content)
{
    balde_template_content_block_t *block = g_new(balde_template_content_block_t, 1);
    block->content = g_strdup(content);
    if (clean_whitespace_next) {
        g_strchug(block->content);
        clean_whitespace_next = FALSE;
    }
    balde_template_block_t *node = g_new(balde_template_block_t, 1);
    node->block = block;
    node->type = BALDE_TEMPLATE_CONTENT_BLOCK;
    nodes = g_list_append(nodes, node);
}

static void
balde_template_print_var_block(const gchar *var)
{
    balde_template_print_var_block_t *block = g_new(balde_template_print_var_block_t, 1);
    block->variable = g_strdup(var);
    balde_template_block_t *node = g_new(balde_template_block_t, 1);
    node->block = block;
    node->type = BALDE_TEMPLATE_PRINT_VAR_BLOCK;
    nodes = g_list_append(nodes, node);
}

static void
balde_template_print_fn_arg(const gchar *arg)
{
    balde_template_fn_arg_t *a = g_new(balde_template_fn_arg_t, 1);
    switch (fn_arg_type) {
        case BALDE_TEMPLATE_FN_ARG_STRING:
            a->content = g_strdup_printf("\"%s\"", arg);
            balde_unescape_single_quoted_strings(&(a->content));
            break;
        default:
            a->content = g_strdup(arg);
    }
    a->type = fn_arg_type;
    fn_args = g_slist_append(fn_args, a);
}

static void
balde_template_print_fn_id(const gchar *fn_id)
{
    fn_name = g_strdup(fn_id);
}

static void
balde_template_print_block(void)
{
    balde_template_print_fn_call_block_t *block = g_new(balde_template_print_fn_call_block_t, 1);
    block->name = fn_name;
    block->args = fn_args;
    balde_template_block_t *node = g_new(balde_template_block_t, 1);
    node->block = block;
    node->type = BALDE_TEMPLATE_PRINT_FN_CALL_BLOCK;
    nodes = g_list_append(nodes, node);
    fn_name = NULL;
    fn_args = NULL;
}


#ifndef YY_MALLOC
#define YY_MALLOC(C, N)		malloc(N)
#endif
#ifndef YY_REALLOC
#define YY_REALLOC(C, P, N)	realloc(P, N)
#endif
#ifndef YY_FREE
#define YY_FREE(C, P)		free(P)
#endif
#ifndef YY_LOCAL
#define YY_LOCAL(T)	static T
#endif
#ifndef YY_ACTION
#define YY_ACTION(T)	static T
#endif
#ifndef YY_RULE
#define YY_RULE(T)	static T
#endif
#ifndef YY_PARSE
#define YY_PARSE(T)	T
#endif
#ifndef YYPARSE
#define YYPARSE		yyparse
#endif
#ifndef YYPARSEFROM
#define YYPARSEFROM	yyparsefrom
#endif
#ifndef YYRELEASE
#define YYRELEASE	yyrelease
#endif
#ifndef YY_BEGIN
#define YY_BEGIN	( yy->__begin= yy->__pos, 1)
#endif
#ifndef YY_END
#define YY_END		( yy->__end= yy->__pos, 1)
#endif
#ifdef YY_DEBUG
# define yyprintf(args)	fprintf args
#else
# define yyprintf(args)
#endif
#ifndef YYSTYPE
#define YYSTYPE	int
#endif
#ifndef YY_STACK_SIZE
#define YY_STACK_SIZE 128
#endif

#ifndef YY_BUFFER_SIZE
#define YY_BUFFER_SIZE 1024
#endif

#ifndef YY_PART

typedef struct _yycontext yycontext;
typedef void (*yyaction)(yycontext *yy, char *yytext, int yyleng);
typedef struct _yythunk { int begin, end;  yyaction  action;  struct _yythunk *next; } yythunk;

struct _yycontext {
  char     *__buf;
  int       __buflen;
  int       __pos;
  int       __limit;
  char     *__text;
  int       __textlen;
  int       __begin;
  int       __end;
  int       __textmax;
  yythunk  *__thunks;
  int       __thunkslen;
  int       __thunkpos;
  YYSTYPE   __;
  YYSTYPE  *__val;
  YYSTYPE  *__vals;
  int       __valslen;
#ifdef YY_CTX_MEMBERS
  YY_CTX_MEMBERS
#endif
};

#ifdef YY_CTX_LOCAL
#define YY_CTX_PARAM_	yycontext *yyctx,
#define YY_CTX_PARAM	yycontext *yyctx
#define YY_CTX_ARG_	yyctx,
#define YY_CTX_ARG	yyctx
#ifndef YY_INPUT
#define YY_INPUT(yy, buf, result, max_size)		\
  {							\
    int yyc= getchar();					\
    result= (EOF == yyc) ? 0 : (*(buf)= yyc, 1);	\
    yyprintf((stderr, "<%c>", yyc));			\
  }
#endif
#else
#define YY_CTX_PARAM_
#define YY_CTX_PARAM
#define YY_CTX_ARG_
#define YY_CTX_ARG
yycontext _yyctx= { 0, 0 };
yycontext *yyctx= &_yyctx;
#ifndef YY_INPUT
#define YY_INPUT(buf, result, max_size)			\
  {							\
    int yyc= getchar();					\
    result= (EOF == yyc) ? 0 : (*(buf)= yyc, 1);	\
    yyprintf((stderr, "<%c>", yyc));			\
  }
#endif
#endif

YY_LOCAL(int) yyrefill(yycontext *yy)
{
  int yyn;
  while (yy->__buflen - yy->__pos < 512)
    {
      yy->__buflen *= 2;
      yy->__buf= (char *)YY_REALLOC(yy, yy->__buf, yy->__buflen);
    }
#ifdef YY_CTX_LOCAL
  YY_INPUT(yy, (yy->__buf + yy->__pos), yyn, (yy->__buflen - yy->__pos));
#else
  YY_INPUT((yy->__buf + yy->__pos), yyn, (yy->__buflen - yy->__pos));
#endif
  if (!yyn) return 0;
  yy->__limit += yyn;
  return 1;
}

YY_LOCAL(int) yymatchDot(yycontext *yy)
{
  if (yy->__pos >= yy->__limit && !yyrefill(yy)) return 0;
  ++yy->__pos;
  return 1;
}

YY_LOCAL(int) yymatchChar(yycontext *yy, int c)
{
  if (yy->__pos >= yy->__limit && !yyrefill(yy)) return 0;
  if ((unsigned char)yy->__buf[yy->__pos] == c)
    {
      ++yy->__pos;
      yyprintf((stderr, "  ok   yymatchChar(yy, %c) @ %s\n", c, yy->__buf+yy->__pos));
      return 1;
    }
  yyprintf((stderr, "  fail yymatchChar(yy, %c) @ %s\n", c, yy->__buf+yy->__pos));
  return 0;
}

YY_LOCAL(int) yymatchString(yycontext *yy, const char *s)
{
  int yysav= yy->__pos;
  while (*s)
    {
      if (yy->__pos >= yy->__limit && !yyrefill(yy)) return 0;
      if (yy->__buf[yy->__pos] != *s)
        {
          yy->__pos= yysav;
          return 0;
        }
      ++s;
      ++yy->__pos;
    }
  return 1;
}

YY_LOCAL(int) yymatchClass(yycontext *yy, unsigned char *bits)
{
  int c;
  if (yy->__pos >= yy->__limit && !yyrefill(yy)) return 0;
  c= (unsigned char)yy->__buf[yy->__pos];
  if (bits[c >> 3] & (1 << (c & 7)))
    {
      ++yy->__pos;
      yyprintf((stderr, "  ok   yymatchClass @ %s\n", yy->__buf+yy->__pos));
      return 1;
    }
  yyprintf((stderr, "  fail yymatchClass @ %s\n", yy->__buf+yy->__pos));
  return 0;
}

YY_LOCAL(void) yyDo(yycontext *yy, yyaction action, int begin, int end)
{
  while (yy->__thunkpos >= yy->__thunkslen)
    {
      yy->__thunkslen *= 2;
      yy->__thunks= (yythunk *)YY_REALLOC(yy, yy->__thunks, sizeof(yythunk) * yy->__thunkslen);
    }
  yy->__thunks[yy->__thunkpos].begin=  begin;
  yy->__thunks[yy->__thunkpos].end=    end;
  yy->__thunks[yy->__thunkpos].action= action;
  ++yy->__thunkpos;
}

YY_LOCAL(int) yyText(yycontext *yy, int begin, int end)
{
  int yyleng= end - begin;
  if (yyleng <= 0)
    yyleng= 0;
  else
    {
      while (yy->__textlen < (yyleng + 1))
	{
	  yy->__textlen *= 2;
	  yy->__text= (char *)YY_REALLOC(yy, yy->__text, yy->__textlen);
	}
      memcpy(yy->__text, yy->__buf + begin, yyleng);
    }
  yy->__text[yyleng]= '\0';
  return yyleng;
}

YY_LOCAL(void) yyDone(yycontext *yy)
{
  int pos;
  for (pos= 0;  pos < yy->__thunkpos;  ++pos)
    {
      yythunk *thunk= &yy->__thunks[pos];
      int yyleng= thunk->end ? yyText(yy, thunk->begin, thunk->end) : thunk->begin;
      yyprintf((stderr, "DO [%d] %p %s\n", pos, thunk->action, yy->__text));
      thunk->action(yy, yy->__text, yyleng);
    }
  yy->__thunkpos= 0;
}

YY_LOCAL(void) yyCommit(yycontext *yy)
{
  if ((yy->__limit -= yy->__pos))
    {
      memmove(yy->__buf, yy->__buf + yy->__pos, yy->__limit);
    }
  yy->__begin -= yy->__pos;
  yy->__end -= yy->__pos;
  yy->__pos= yy->__thunkpos= 0;
}

YY_LOCAL(int) yyAccept(yycontext *yy, int tp0)
{
  if (tp0)
    {
      fprintf(stderr, "accept denied at %d\n", tp0);
      return 0;
    }
  else
    {
      yyDone(yy);
      yyCommit(yy);
    }
  return 1;
}

YY_LOCAL(void) yyPush(yycontext *yy, char *text, int count)
{
  yy->__val += count;
  while (yy->__valslen <= yy->__val - yy->__vals)
    {
      long offset= yy->__val - yy->__vals;
      yy->__valslen *= 2;
      yy->__vals= (YYSTYPE *)YY_REALLOC(yy, yy->__vals, sizeof(YYSTYPE) * yy->__valslen);
      yy->__val= yy->__vals + offset;
    }
}
YY_LOCAL(void) yyPop(yycontext *yy, char *text, int count)   { yy->__val -= count; }
YY_LOCAL(void) yySet(yycontext *yy, char *text, int count)   { yy->__val[count]= yy->__; }

#endif /* YY_PART */

#define	YYACCEPT	yyAccept(yy, yythunkpos0)

YY_RULE(int) yy_print_fn(yycontext *yy); /* 42 */
YY_RULE(int) yy_print_fn_id(yycontext *yy); /* 41 */
YY_RULE(int) yy_print_fn_args(yycontext *yy); /* 40 */
YY_RULE(int) yy_print_fn_arg(yycontext *yy); /* 39 */
YY_RULE(int) yy_print_fn_arg_null(yycontext *yy); /* 38 */
YY_RULE(int) yy_print_fn_arg_bool(yycontext *yy); /* 37 */
YY_RULE(int) yy_print_fn_arg_float(yycontext *yy); /* 36 */
YY_RULE(int) yy_print_fn_arg_int(yycontext *yy); /* 35 */
YY_RULE(int) yy_print_fn_arg_str(yycontext *yy); /* 34 */
YY_RULE(int) yy_print_fn_arg_var(yycontext *yy); /* 33 */
YY_RULE(int) yy_print_var(yycontext *yy); /* 32 */
YY_RULE(int) yy_print_close(yycontext *yy); /* 31 */
YY_RULE(int) yy_print_open(yycontext *yy); /* 30 */
YY_RULE(int) yy_if_close(yycontext *yy); /* 29 */
YY_RULE(int) yy_if_open(yycontext *yy); /* 28 */
YY_RULE(int) yy_include_close(yycontext *yy); /* 27 */
YY_RULE(int) yy_include_open(yycontext *yy); /* 26 */
YY_RULE(int) yy_import_close(yycontext *yy); /* 25 */
YY_RULE(int) yy_import_open(yycontext *yy); /* 24 */
YY_RULE(int) yy_clean_whitespace_close(yycontext *yy); /* 23 */
YY_RULE(int) yy_clean_whitespace_open(yycontext *yy); /* 22 */
YY_RULE(int) yy_null(yycontext *yy); /* 21 */
YY_RULE(int) yy_bool(yycontext *yy); /* 20 */
YY_RULE(int) yy_float(yycontext *yy); /* 19 */
YY_RULE(int) yy_sign(yycontext *yy); /* 18 */
YY_RULE(int) yy_int(yycontext *yy); /* 17 */
YY_RULE(int) yy_str(yycontext *yy); /* 16 */
YY_RULE(int) yy_unq_str2(yycontext *yy); /* 15 */
YY_RULE(int) yy_unq_str1(yycontext *yy); /* 14 */
YY_RULE(int) yy_id(yycontext *yy); /* 13 */
YY_RULE(int) yy__(yycontext *yy); /* 12 */
YY_RULE(int) yy_eof(yycontext *yy); /* 11 */
YY_RULE(int) yy_eol(yycontext *yy); /* 10 */
YY_RULE(int) yy_anything(yycontext *yy); /* 9 */
YY_RULE(int) yy_content(yycontext *yy); /* 8 */
YY_RULE(int) yy_print_call(yycontext *yy); /* 7 */
YY_RULE(int) yy_if_end(yycontext *yy); /* 6 */
YY_RULE(int) yy_else(yycontext *yy); /* 5 */
YY_RULE(int) yy_if(yycontext *yy); /* 4 */
YY_RULE(int) yy_include(yycontext *yy); /* 3 */
YY_RULE(int) yy_import(yycontext *yy); /* 2 */
YY_RULE(int) yy_page(yycontext *yy); /* 1 */

YY_ACTION(void) yy_1_content(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_content\n"));
  {
   balde_template_content_block(yytext); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_fn(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_fn\n"));
  {
   balde_template_print_block(); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_fn_id(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_fn_id\n"));
  {
   balde_template_print_fn_id(yytext); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_fn_arg(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_fn_arg\n"));
  {
   balde_template_print_fn_arg(yytext); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_fn_arg_null(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_fn_arg_null\n"));
  {
   fn_arg_type = BALDE_TEMPLATE_FN_ARG_NULL; ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_fn_arg_bool(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_fn_arg_bool\n"));
  {
   fn_arg_type = BALDE_TEMPLATE_FN_ARG_BOOL; ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_fn_arg_float(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_fn_arg_float\n"));
  {
   fn_arg_type = BALDE_TEMPLATE_FN_ARG_FLOAT; ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_fn_arg_int(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_fn_arg_int\n"));
  {
   fn_arg_type = BALDE_TEMPLATE_FN_ARG_INT; ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_fn_arg_str(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_fn_arg_str\n"));
  {
   fn_arg_type = BALDE_TEMPLATE_FN_ARG_STRING; ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_fn_arg_var(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_fn_arg_var\n"));
  {
   fn_arg_type = BALDE_TEMPLATE_FN_ARG_VAR; ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_print_var(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_print_var\n"));
  {
   balde_template_print_var_block(yytext); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_if_end(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_if_end\n"));
  {
   balde_template_endif_block(); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_else(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_else\n"));
  {
   balde_template_else_block(); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_if(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_if\n"));
  {
   balde_template_if_block(yytext); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_include(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_include\n"));
  {
   balde_template_include_block(yytext); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_import(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_import\n"));
  {
   balde_template_import_block(yytext); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_clean_whitespace_close(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_clean_whitespace_close\n"));
  {
   balde_template_clean_whitespace_next(); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_clean_whitespace_open(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_clean_whitespace_open\n"));
  {
   balde_template_clean_whitespace_prev(); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}
YY_ACTION(void) yy_1_page(yycontext *yy, char *yytext, int yyleng)
{
#define __ yy->__
#define yypos yy->__pos
#define yythunkpos yy->__thunkpos
  yyprintf((stderr, "do yy_1_page\n"));
  {
   g_error("Syntax error near: %s", yytext); ;
  }
#undef yythunkpos
#undef yypos
#undef yy
}

YY_RULE(int) yy_print_fn(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn"));  if (!yy_print_fn_id(yy)) goto l1;  if (!yy__(yy)) goto l1;  if (!yymatchChar(yy, '(')) goto l1;  if (!yy_print_fn_args(yy)) goto l1;  if (!yymatchChar(yy, ')')) goto l1;  yyDo(yy, yy_1_print_fn, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn", yy->__buf+yy->__pos));
  return 1;
  l1:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_fn_id(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn_id"));  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_BEGIN)) goto l2;
#undef yytext
#undef yyleng
  }  if (!yy_id(yy)) goto l2;  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_END)) goto l2;
#undef yytext
#undef yyleng
  }  yyDo(yy, yy_1_print_fn_id, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn_id", yy->__buf+yy->__pos));
  return 1;
  l2:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn_id", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_fn_args(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn_args"));  if (!yy__(yy)) goto l3;
  l4:;	
  {  int yypos5= yy->__pos, yythunkpos5= yy->__thunkpos;  if (!yy_print_fn_arg(yy)) goto l5;
  l6:;	
  {  int yypos7= yy->__pos, yythunkpos7= yy->__thunkpos;  if (!yy__(yy)) goto l7;  if (!yymatchChar(yy, ',')) goto l7;  if (!yy__(yy)) goto l7;  if (!yy_print_fn_arg(yy)) goto l7;  goto l6;
  l7:;	  yy->__pos= yypos7; yy->__thunkpos= yythunkpos7;
  }  if (!yy__(yy)) goto l5;  goto l4;
  l5:;	  yy->__pos= yypos5; yy->__thunkpos= yythunkpos5;
  }
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn_args", yy->__buf+yy->__pos));
  return 1;
  l3:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn_args", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_fn_arg(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn_arg"));
  {  int yypos9= yy->__pos, yythunkpos9= yy->__thunkpos;  if (!yy_print_fn_arg_bool(yy)) goto l10;  goto l9;
  l10:;	  yy->__pos= yypos9; yy->__thunkpos= yythunkpos9;  if (!yy_print_fn_arg_null(yy)) goto l11;  goto l9;
  l11:;	  yy->__pos= yypos9; yy->__thunkpos= yythunkpos9;  if (!yy_print_fn_arg_float(yy)) goto l12;  goto l9;
  l12:;	  yy->__pos= yypos9; yy->__thunkpos= yythunkpos9;  if (!yy_print_fn_arg_int(yy)) goto l13;  goto l9;
  l13:;	  yy->__pos= yypos9; yy->__thunkpos= yythunkpos9;  if (!yy_print_fn_arg_var(yy)) goto l14;  goto l9;
  l14:;	  yy->__pos= yypos9; yy->__thunkpos= yythunkpos9;  if (!yy_print_fn_arg_str(yy)) goto l8;
  }
  l9:;	  yyDo(yy, yy_1_print_fn_arg, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn_arg", yy->__buf+yy->__pos));
  return 1;
  l8:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn_arg", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_fn_arg_null(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn_arg_null"));  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_BEGIN)) goto l15;
#undef yytext
#undef yyleng
  }  if (!yy_null(yy)) goto l15;  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_END)) goto l15;
#undef yytext
#undef yyleng
  }  yyDo(yy, yy_1_print_fn_arg_null, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn_arg_null", yy->__buf+yy->__pos));
  return 1;
  l15:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn_arg_null", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_fn_arg_bool(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn_arg_bool"));  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_BEGIN)) goto l16;
#undef yytext
#undef yyleng
  }  if (!yy_bool(yy)) goto l16;  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_END)) goto l16;
#undef yytext
#undef yyleng
  }  yyDo(yy, yy_1_print_fn_arg_bool, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn_arg_bool", yy->__buf+yy->__pos));
  return 1;
  l16:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn_arg_bool", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_fn_arg_float(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn_arg_float"));  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_BEGIN)) goto l17;
#undef yytext
#undef yyleng
  }  if (!yy_float(yy)) goto l17;  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_END)) goto l17;
#undef yytext
#undef yyleng
  }  yyDo(yy, yy_1_print_fn_arg_float, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn_arg_float", yy->__buf+yy->__pos));
  return 1;
  l17:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn_arg_float", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_fn_arg_int(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn_arg_int"));  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_BEGIN)) goto l18;
#undef yytext
#undef yyleng
  }  if (!yy_int(yy)) goto l18;  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_END)) goto l18;
#undef yytext
#undef yyleng
  }  yyDo(yy, yy_1_print_fn_arg_int, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn_arg_int", yy->__buf+yy->__pos));
  return 1;
  l18:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn_arg_int", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_fn_arg_str(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn_arg_str"));  if (!yy_str(yy)) goto l19;  yyDo(yy, yy_1_print_fn_arg_str, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn_arg_str", yy->__buf+yy->__pos));
  return 1;
  l19:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn_arg_str", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_fn_arg_var(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_fn_arg_var"));  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_BEGIN)) goto l20;
#undef yytext
#undef yyleng
  }  if (!yy_id(yy)) goto l20;  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_END)) goto l20;
#undef yytext
#undef yyleng
  }  yyDo(yy, yy_1_print_fn_arg_var, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_fn_arg_var", yy->__buf+yy->__pos));
  return 1;
  l20:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_fn_arg_var", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_var(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_var"));  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_BEGIN)) goto l21;
#undef yytext
#undef yyleng
  }  if (!yy_id(yy)) goto l21;  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_END)) goto l21;
#undef yytext
#undef yyleng
  }  yyDo(yy, yy_1_print_var, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "print_var", yy->__buf+yy->__pos));
  return 1;
  l21:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_var", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_close(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_close"));  if (!yy__(yy)) goto l22;  if (!yymatchString(yy, "}}")) goto l22;
  yyprintf((stderr, "  ok   %s @ %s\n", "print_close", yy->__buf+yy->__pos));
  return 1;
  l22:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_close", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_open(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_open"));  if (!yymatchString(yy, "{{")) goto l23;  if (!yy__(yy)) goto l23;
  yyprintf((stderr, "  ok   %s @ %s\n", "print_open", yy->__buf+yy->__pos));
  return 1;
  l23:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_open", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_if_close(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "if_close"));  if (!yy__(yy)) goto l24;
  {  int yypos25= yy->__pos, yythunkpos25= yy->__thunkpos;  if (!yy_clean_whitespace_close(yy)) goto l25;  goto l26;
  l25:;	  yy->__pos= yypos25; yy->__thunkpos= yythunkpos25;
  }
  l26:;	  if (!yymatchString(yy, "%}")) goto l24;
  yyprintf((stderr, "  ok   %s @ %s\n", "if_close", yy->__buf+yy->__pos));
  return 1;
  l24:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "if_close", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_if_open(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "if_open"));  if (!yymatchString(yy, "{%")) goto l27;
  {  int yypos28= yy->__pos, yythunkpos28= yy->__thunkpos;  if (!yy_clean_whitespace_open(yy)) goto l28;  goto l29;
  l28:;	  yy->__pos= yypos28; yy->__thunkpos= yythunkpos28;
  }
  l29:;	  if (!yy__(yy)) goto l27;
  yyprintf((stderr, "  ok   %s @ %s\n", "if_open", yy->__buf+yy->__pos));
  return 1;
  l27:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "if_open", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_include_close(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "include_close"));  if (!yy__(yy)) goto l30;
  {  int yypos31= yy->__pos, yythunkpos31= yy->__thunkpos;  if (!yy_clean_whitespace_close(yy)) goto l31;  goto l32;
  l31:;	  yy->__pos= yypos31; yy->__thunkpos= yythunkpos31;
  }
  l32:;	  if (!yymatchString(yy, "%}")) goto l30;
  yyprintf((stderr, "  ok   %s @ %s\n", "include_close", yy->__buf+yy->__pos));
  return 1;
  l30:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "include_close", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_include_open(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "include_open"));  if (!yymatchString(yy, "{%")) goto l33;
  {  int yypos34= yy->__pos, yythunkpos34= yy->__thunkpos;  if (!yy_clean_whitespace_open(yy)) goto l34;  goto l35;
  l34:;	  yy->__pos= yypos34; yy->__thunkpos= yythunkpos34;
  }
  l35:;	  if (!yy__(yy)) goto l33;
  yyprintf((stderr, "  ok   %s @ %s\n", "include_open", yy->__buf+yy->__pos));
  return 1;
  l33:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "include_open", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_import_close(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "import_close"));  if (!yy__(yy)) goto l36;
  {  int yypos37= yy->__pos, yythunkpos37= yy->__thunkpos;  if (!yy_clean_whitespace_close(yy)) goto l37;  goto l38;
  l37:;	  yy->__pos= yypos37; yy->__thunkpos= yythunkpos37;
  }
  l38:;	  if (!yymatchString(yy, "%}")) goto l36;
  yyprintf((stderr, "  ok   %s @ %s\n", "import_close", yy->__buf+yy->__pos));
  return 1;
  l36:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "import_close", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_import_open(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "import_open"));  if (!yymatchString(yy, "{%")) goto l39;
  {  int yypos40= yy->__pos, yythunkpos40= yy->__thunkpos;  if (!yy_clean_whitespace_open(yy)) goto l40;  goto l41;
  l40:;	  yy->__pos= yypos40; yy->__thunkpos= yythunkpos40;
  }
  l41:;	  if (!yy__(yy)) goto l39;
  yyprintf((stderr, "  ok   %s @ %s\n", "import_open", yy->__buf+yy->__pos));
  return 1;
  l39:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "import_open", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_clean_whitespace_close(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "clean_whitespace_close"));  if (!yymatchChar(yy, '-')) goto l42;  yyDo(yy, yy_1_clean_whitespace_close, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "clean_whitespace_close", yy->__buf+yy->__pos));
  return 1;
  l42:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "clean_whitespace_close", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_clean_whitespace_open(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "clean_whitespace_open"));  if (!yymatchChar(yy, '-')) goto l43;  yyDo(yy, yy_1_clean_whitespace_open, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "clean_whitespace_open", yy->__buf+yy->__pos));
  return 1;
  l43:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "clean_whitespace_open", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_null(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "null"));  if (!yymatchString(yy, "NULL")) goto l44;
  yyprintf((stderr, "  ok   %s @ %s\n", "null", yy->__buf+yy->__pos));
  return 1;
  l44:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "null", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_bool(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "bool"));
  {  int yypos46= yy->__pos, yythunkpos46= yy->__thunkpos;  if (!yymatchString(yy, "TRUE")) goto l47;  goto l46;
  l47:;	  yy->__pos= yypos46; yy->__thunkpos= yythunkpos46;  if (!yymatchString(yy, "FALSE")) goto l45;
  }
  l46:;	
  yyprintf((stderr, "  ok   %s @ %s\n", "bool", yy->__buf+yy->__pos));
  return 1;
  l45:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "bool", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_float(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "float"));
  {  int yypos49= yy->__pos, yythunkpos49= yy->__thunkpos;  if (!yy_sign(yy)) goto l49;  goto l50;
  l49:;	  yy->__pos= yypos49; yy->__thunkpos= yythunkpos49;
  }
  l50:;	  if (!yymatchClass(yy, (unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")) goto l48;
  l51:;	
  {  int yypos52= yy->__pos, yythunkpos52= yy->__thunkpos;  if (!yymatchClass(yy, (unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")) goto l52;  goto l51;
  l52:;	  yy->__pos= yypos52; yy->__thunkpos= yythunkpos52;
  }  if (!yymatchChar(yy, '.')) goto l48;  if (!yymatchClass(yy, (unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")) goto l48;
  l53:;	
  {  int yypos54= yy->__pos, yythunkpos54= yy->__thunkpos;  if (!yymatchClass(yy, (unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")) goto l54;  goto l53;
  l54:;	  yy->__pos= yypos54; yy->__thunkpos= yythunkpos54;
  }
  yyprintf((stderr, "  ok   %s @ %s\n", "float", yy->__buf+yy->__pos));
  return 1;
  l48:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "float", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_sign(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "sign"));
  {  int yypos56= yy->__pos, yythunkpos56= yy->__thunkpos;  if (!yymatchChar(yy, '+')) goto l57;  goto l56;
  l57:;	  yy->__pos= yypos56; yy->__thunkpos= yythunkpos56;  if (!yymatchChar(yy, '-')) goto l55;
  }
  l56:;	
  yyprintf((stderr, "  ok   %s @ %s\n", "sign", yy->__buf+yy->__pos));
  return 1;
  l55:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "sign", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_int(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "int"));
  {  int yypos59= yy->__pos, yythunkpos59= yy->__thunkpos;  if (!yy_sign(yy)) goto l59;  goto l60;
  l59:;	  yy->__pos= yypos59; yy->__thunkpos= yythunkpos59;
  }
  l60:;	  if (!yymatchClass(yy, (unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")) goto l58;
  l61:;	
  {  int yypos62= yy->__pos, yythunkpos62= yy->__thunkpos;  if (!yymatchClass(yy, (unsigned char *)"\000\000\000\000\000\000\377\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")) goto l62;  goto l61;
  l62:;	  yy->__pos= yypos62; yy->__thunkpos= yythunkpos62;
  }
  yyprintf((stderr, "  ok   %s @ %s\n", "int", yy->__buf+yy->__pos));
  return 1;
  l58:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "int", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_str(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "str"));
  {  int yypos64= yy->__pos, yythunkpos64= yy->__thunkpos;  if (!yymatchChar(yy, '"')) goto l65;  if (!yy_unq_str1(yy)) goto l65;  if (!yymatchChar(yy, '"')) goto l65;  goto l64;
  l65:;	  yy->__pos= yypos64; yy->__thunkpos= yythunkpos64;  if (!yymatchChar(yy, '\'')) goto l63;  if (!yy_unq_str2(yy)) goto l63;  if (!yymatchChar(yy, '\'')) goto l63;
  }
  l64:;	
  yyprintf((stderr, "  ok   %s @ %s\n", "str", yy->__buf+yy->__pos));
  return 1;
  l63:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "str", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_unq_str2(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "unq_str2"));  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_BEGIN)) goto l66;
#undef yytext
#undef yyleng
  }
  l67:;	
  {  int yypos68= yy->__pos, yythunkpos68= yy->__thunkpos;
  {  int yypos69= yy->__pos, yythunkpos69= yy->__thunkpos;  if (!yymatchChar(yy, '\\')) goto l70;  if (!yymatchChar(yy, '\'')) goto l70;  goto l69;
  l70:;	  yy->__pos= yypos69; yy->__thunkpos= yythunkpos69;
  {  int yypos71= yy->__pos, yythunkpos71= yy->__thunkpos;  if (!yymatchChar(yy, '\'')) goto l71;  goto l68;
  l71:;	  yy->__pos= yypos71; yy->__thunkpos= yythunkpos71;
  }  if (!yymatchDot(yy)) goto l68;
  }
  l69:;	  goto l67;
  l68:;	  yy->__pos= yypos68; yy->__thunkpos= yythunkpos68;
  }  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_END)) goto l66;
#undef yytext
#undef yyleng
  }
  yyprintf((stderr, "  ok   %s @ %s\n", "unq_str2", yy->__buf+yy->__pos));
  return 1;
  l66:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "unq_str2", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_unq_str1(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "unq_str1"));  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_BEGIN)) goto l72;
#undef yytext
#undef yyleng
  }
  l73:;	
  {  int yypos74= yy->__pos, yythunkpos74= yy->__thunkpos;
  {  int yypos75= yy->__pos, yythunkpos75= yy->__thunkpos;  if (!yymatchChar(yy, '\\')) goto l76;  if (!yymatchChar(yy, '"')) goto l76;  goto l75;
  l76:;	  yy->__pos= yypos75; yy->__thunkpos= yythunkpos75;
  {  int yypos77= yy->__pos, yythunkpos77= yy->__thunkpos;  if (!yymatchChar(yy, '"')) goto l77;  goto l74;
  l77:;	  yy->__pos= yypos77; yy->__thunkpos= yythunkpos77;
  }  if (!yymatchDot(yy)) goto l74;
  }
  l75:;	  goto l73;
  l74:;	  yy->__pos= yypos74; yy->__thunkpos= yythunkpos74;
  }  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_END)) goto l72;
#undef yytext
#undef yyleng
  }
  yyprintf((stderr, "  ok   %s @ %s\n", "unq_str1", yy->__buf+yy->__pos));
  return 1;
  l72:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "unq_str1", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_id(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "id"));  if (!yymatchClass(yy, (unsigned char *)"\000\000\000\000\000\000\000\000\376\377\377\007\376\377\377\007\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")) goto l78;
  l79:;	
  {  int yypos80= yy->__pos, yythunkpos80= yy->__thunkpos;  if (!yymatchClass(yy, (unsigned char *)"\000\000\000\000\000\000\377\003\376\377\377\207\376\377\377\007\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")) goto l80;  goto l79;
  l80:;	  yy->__pos= yypos80; yy->__thunkpos= yythunkpos80;
  }
  yyprintf((stderr, "  ok   %s @ %s\n", "id", yy->__buf+yy->__pos));
  return 1;
  l78:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "id", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy__(yycontext *yy)
{
  yyprintf((stderr, "%s\n", "_"));
  l82:;	
  {  int yypos83= yy->__pos, yythunkpos83= yy->__thunkpos;  if (!yymatchClass(yy, (unsigned char *)"\000\002\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")) goto l83;  goto l82;
  l83:;	  yy->__pos= yypos83; yy->__thunkpos= yythunkpos83;
  }
  yyprintf((stderr, "  ok   %s @ %s\n", "_", yy->__buf+yy->__pos));
  return 1;
}
YY_RULE(int) yy_eof(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "eof"));
  {  int yypos85= yy->__pos, yythunkpos85= yy->__thunkpos;  if (!yymatchDot(yy)) goto l85;  goto l84;
  l85:;	  yy->__pos= yypos85; yy->__thunkpos= yythunkpos85;
  }
  yyprintf((stderr, "  ok   %s @ %s\n", "eof", yy->__buf+yy->__pos));
  return 1;
  l84:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "eof", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_eol(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "eol"));
  {  int yypos87= yy->__pos, yythunkpos87= yy->__thunkpos;  if (!yymatchChar(yy, '\n')) goto l88;  goto l87;
  l88:;	  yy->__pos= yypos87; yy->__thunkpos= yythunkpos87;  if (!yymatchString(yy, "\r\n")) goto l89;  goto l87;
  l89:;	  yy->__pos= yypos87; yy->__thunkpos= yythunkpos87;  if (!yymatchChar(yy, '\r')) goto l86;
  }
  l87:;	
  yyprintf((stderr, "  ok   %s @ %s\n", "eol", yy->__buf+yy->__pos));
  return 1;
  l86:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "eol", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_anything(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "anything"));  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_BEGIN)) goto l90;
#undef yytext
#undef yyleng
  }
  l91:;	
  {  int yypos92= yy->__pos, yythunkpos92= yy->__thunkpos;
  {  int yypos93= yy->__pos, yythunkpos93= yy->__thunkpos;  if (!yy_eol(yy)) goto l93;  goto l92;
  l93:;	  yy->__pos= yypos93; yy->__thunkpos= yythunkpos93;
  }  if (!yymatchDot(yy)) goto l92;  goto l91;
  l92:;	  yy->__pos= yypos92; yy->__thunkpos= yythunkpos92;
  }  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_END)) goto l90;
#undef yytext
#undef yyleng
  }  if (!yy_eol(yy)) goto l90;
  yyprintf((stderr, "  ok   %s @ %s\n", "anything", yy->__buf+yy->__pos));
  return 1;
  l90:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "anything", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_content(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "content"));  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_BEGIN)) goto l94;
#undef yytext
#undef yyleng
  }
  {  int yypos97= yy->__pos, yythunkpos97= yy->__thunkpos;  if (!yy_eof(yy)) goto l97;  goto l94;
  l97:;	  yy->__pos= yypos97; yy->__thunkpos= yythunkpos97;
  }
  {  int yypos98= yy->__pos, yythunkpos98= yy->__thunkpos;  if (!yy_import_open(yy)) goto l98;  goto l94;
  l98:;	  yy->__pos= yypos98; yy->__thunkpos= yythunkpos98;
  }
  {  int yypos99= yy->__pos, yythunkpos99= yy->__thunkpos;  if (!yy_import_close(yy)) goto l99;  goto l94;
  l99:;	  yy->__pos= yypos99; yy->__thunkpos= yythunkpos99;
  }
  {  int yypos100= yy->__pos, yythunkpos100= yy->__thunkpos;  if (!yy_include_open(yy)) goto l100;  goto l94;
  l100:;	  yy->__pos= yypos100; yy->__thunkpos= yythunkpos100;
  }
  {  int yypos101= yy->__pos, yythunkpos101= yy->__thunkpos;  if (!yy_include_close(yy)) goto l101;  goto l94;
  l101:;	  yy->__pos= yypos101; yy->__thunkpos= yythunkpos101;
  }
  {  int yypos102= yy->__pos, yythunkpos102= yy->__thunkpos;  if (!yy_if_open(yy)) goto l102;  goto l94;
  l102:;	  yy->__pos= yypos102; yy->__thunkpos= yythunkpos102;
  }
  {  int yypos103= yy->__pos, yythunkpos103= yy->__thunkpos;  if (!yy_if_close(yy)) goto l103;  goto l94;
  l103:;	  yy->__pos= yypos103; yy->__thunkpos= yythunkpos103;
  }
  {  int yypos104= yy->__pos, yythunkpos104= yy->__thunkpos;  if (!yy_print_open(yy)) goto l104;  goto l94;
  l104:;	  yy->__pos= yypos104; yy->__thunkpos= yythunkpos104;
  }
  {  int yypos105= yy->__pos, yythunkpos105= yy->__thunkpos;  if (!yy_print_close(yy)) goto l105;  goto l94;
  l105:;	  yy->__pos= yypos105; yy->__thunkpos= yythunkpos105;
  }  if (!yymatchDot(yy)) goto l94;
  l95:;	
  {  int yypos96= yy->__pos, yythunkpos96= yy->__thunkpos;
  {  int yypos106= yy->__pos, yythunkpos106= yy->__thunkpos;  if (!yy_eof(yy)) goto l106;  goto l96;
  l106:;	  yy->__pos= yypos106; yy->__thunkpos= yythunkpos106;
  }
  {  int yypos107= yy->__pos, yythunkpos107= yy->__thunkpos;  if (!yy_import_open(yy)) goto l107;  goto l96;
  l107:;	  yy->__pos= yypos107; yy->__thunkpos= yythunkpos107;
  }
  {  int yypos108= yy->__pos, yythunkpos108= yy->__thunkpos;  if (!yy_import_close(yy)) goto l108;  goto l96;
  l108:;	  yy->__pos= yypos108; yy->__thunkpos= yythunkpos108;
  }
  {  int yypos109= yy->__pos, yythunkpos109= yy->__thunkpos;  if (!yy_include_open(yy)) goto l109;  goto l96;
  l109:;	  yy->__pos= yypos109; yy->__thunkpos= yythunkpos109;
  }
  {  int yypos110= yy->__pos, yythunkpos110= yy->__thunkpos;  if (!yy_include_close(yy)) goto l110;  goto l96;
  l110:;	  yy->__pos= yypos110; yy->__thunkpos= yythunkpos110;
  }
  {  int yypos111= yy->__pos, yythunkpos111= yy->__thunkpos;  if (!yy_if_open(yy)) goto l111;  goto l96;
  l111:;	  yy->__pos= yypos111; yy->__thunkpos= yythunkpos111;
  }
  {  int yypos112= yy->__pos, yythunkpos112= yy->__thunkpos;  if (!yy_if_close(yy)) goto l112;  goto l96;
  l112:;	  yy->__pos= yypos112; yy->__thunkpos= yythunkpos112;
  }
  {  int yypos113= yy->__pos, yythunkpos113= yy->__thunkpos;  if (!yy_print_open(yy)) goto l113;  goto l96;
  l113:;	  yy->__pos= yypos113; yy->__thunkpos= yythunkpos113;
  }
  {  int yypos114= yy->__pos, yythunkpos114= yy->__thunkpos;  if (!yy_print_close(yy)) goto l114;  goto l96;
  l114:;	  yy->__pos= yypos114; yy->__thunkpos= yythunkpos114;
  }  if (!yymatchDot(yy)) goto l96;  goto l95;
  l96:;	  yy->__pos= yypos96; yy->__thunkpos= yythunkpos96;
  }  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_END)) goto l94;
#undef yytext
#undef yyleng
  }  yyDo(yy, yy_1_content, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "content", yy->__buf+yy->__pos));
  return 1;
  l94:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "content", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_print_call(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "print_call"));  if (!yy_print_open(yy)) goto l115;
  {  int yypos116= yy->__pos, yythunkpos116= yy->__thunkpos;  if (!yy_print_fn(yy)) goto l117;  goto l116;
  l117:;	  yy->__pos= yypos116; yy->__thunkpos= yythunkpos116;  if (!yy_print_var(yy)) goto l115;
  }
  l116:;	  if (!yy_print_close(yy)) goto l115;
  yyprintf((stderr, "  ok   %s @ %s\n", "print_call", yy->__buf+yy->__pos));
  return 1;
  l115:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "print_call", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_if_end(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "if_end"));  if (!yy_if_open(yy)) goto l118;  if (!yymatchString(yy, "endif")) goto l118;  if (!yy_if_close(yy)) goto l118;  yyDo(yy, yy_1_if_end, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "if_end", yy->__buf+yy->__pos));
  return 1;
  l118:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "if_end", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_else(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "else"));  if (!yy_if_open(yy)) goto l119;  if (!yymatchString(yy, "else")) goto l119;  if (!yy_if_close(yy)) goto l119;  yyDo(yy, yy_1_else, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "else", yy->__buf+yy->__pos));
  return 1;
  l119:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "else", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_if(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "if"));  if (!yy_if_open(yy)) goto l120;  if (!yymatchString(yy, "if")) goto l120;  if (!yymatchChar(yy, ' ')) goto l120;
  l121:;	
  {  int yypos122= yy->__pos, yythunkpos122= yy->__thunkpos;  if (!yymatchChar(yy, ' ')) goto l122;  goto l121;
  l122:;	  yy->__pos= yypos122; yy->__thunkpos= yythunkpos122;
  }  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_BEGIN)) goto l120;
#undef yytext
#undef yyleng
  }  if (!yy_id(yy)) goto l120;  yyText(yy, yy->__begin, yy->__end);  {
#define yytext yy->__text
#define yyleng yy->__textlen
if (!(YY_END)) goto l120;
#undef yytext
#undef yyleng
  }  if (!yy_if_close(yy)) goto l120;  yyDo(yy, yy_1_if, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "if", yy->__buf+yy->__pos));
  return 1;
  l120:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "if", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_include(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "include"));  if (!yy_include_open(yy)) goto l123;  if (!yymatchString(yy, "include")) goto l123;  if (!yymatchChar(yy, ' ')) goto l123;
  l124:;	
  {  int yypos125= yy->__pos, yythunkpos125= yy->__thunkpos;  if (!yymatchChar(yy, ' ')) goto l125;  goto l124;
  l125:;	  yy->__pos= yypos125; yy->__thunkpos= yythunkpos125;
  }  if (!yy_str(yy)) goto l123;  if (!yy_include_close(yy)) goto l123;  yyDo(yy, yy_1_include, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "include", yy->__buf+yy->__pos));
  return 1;
  l123:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "include", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_import(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "import"));  if (!yy_import_open(yy)) goto l126;  if (!yymatchString(yy, "import")) goto l126;  if (!yymatchChar(yy, ' ')) goto l126;
  l127:;	
  {  int yypos128= yy->__pos, yythunkpos128= yy->__thunkpos;  if (!yymatchChar(yy, ' ')) goto l128;  goto l127;
  l128:;	  yy->__pos= yypos128; yy->__thunkpos= yythunkpos128;
  }  if (!yy_str(yy)) goto l126;  if (!yy_import_close(yy)) goto l126;  yyDo(yy, yy_1_import, yy->__begin, yy->__end);
  yyprintf((stderr, "  ok   %s @ %s\n", "import", yy->__buf+yy->__pos));
  return 1;
  l126:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "import", yy->__buf+yy->__pos));
  return 0;
}
YY_RULE(int) yy_page(yycontext *yy)
{  int yypos0= yy->__pos, yythunkpos0= yy->__thunkpos;
  yyprintf((stderr, "%s\n", "page"));
  {  int yypos130= yy->__pos, yythunkpos130= yy->__thunkpos;  if (!yy_import(yy)) goto l131;  goto l130;
  l131:;	  yy->__pos= yypos130; yy->__thunkpos= yythunkpos130;  if (!yy_include(yy)) goto l132;  goto l130;
  l132:;	  yy->__pos= yypos130; yy->__thunkpos= yythunkpos130;  if (!yy_if(yy)) goto l133;  goto l130;
  l133:;	  yy->__pos= yypos130; yy->__thunkpos= yythunkpos130;  if (!yy_else(yy)) goto l134;  goto l130;
  l134:;	  yy->__pos= yypos130; yy->__thunkpos= yythunkpos130;  if (!yy_if_end(yy)) goto l135;  goto l130;
  l135:;	  yy->__pos= yypos130; yy->__thunkpos= yythunkpos130;  if (!yy_print_call(yy)) goto l136;  goto l130;
  l136:;	  yy->__pos= yypos130; yy->__thunkpos= yythunkpos130;  if (!yy_content(yy)) goto l137;  goto l130;
  l137:;	  yy->__pos= yypos130; yy->__thunkpos= yythunkpos130;  if (!yy_anything(yy)) goto l129;  yyDo(yy, yy_1_page, yy->__begin, yy->__end);
  }
  l130:;	
  yyprintf((stderr, "  ok   %s @ %s\n", "page", yy->__buf+yy->__pos));
  return 1;
  l129:;	  yy->__pos= yypos0; yy->__thunkpos= yythunkpos0;
  yyprintf((stderr, "  fail %s @ %s\n", "page", yy->__buf+yy->__pos));
  return 0;
}

#ifndef YY_PART

typedef int (*yyrule)(yycontext *yy);

YY_PARSE(int) YYPARSEFROM(YY_CTX_PARAM_ yyrule yystart)
{
  int yyok;
  if (!yyctx->__buflen)
    {
      yyctx->__buflen= YY_BUFFER_SIZE;
      yyctx->__buf= (char *)YY_MALLOC(yyctx, yyctx->__buflen);
      yyctx->__textlen= YY_BUFFER_SIZE;
      yyctx->__text= (char *)YY_MALLOC(yyctx, yyctx->__textlen);
      yyctx->__thunkslen= YY_STACK_SIZE;
      yyctx->__thunks= (yythunk *)YY_MALLOC(yyctx, sizeof(yythunk) * yyctx->__thunkslen);
      yyctx->__valslen= YY_STACK_SIZE;
      yyctx->__vals= (YYSTYPE *)YY_MALLOC(yyctx, sizeof(YYSTYPE) * yyctx->__valslen);
      yyctx->__begin= yyctx->__end= yyctx->__pos= yyctx->__limit= yyctx->__thunkpos= 0;
    }
  yyctx->__begin= yyctx->__end= yyctx->__pos;
  yyctx->__thunkpos= 0;
  yyctx->__val= yyctx->__vals;
  yyok= yystart(yyctx);
  if (yyok) yyDone(yyctx);
  yyCommit(yyctx);
  return yyok;
}

YY_PARSE(int) YYPARSE(YY_CTX_PARAM)
{
  return YYPARSEFROM(YY_CTX_ARG_ yy_page);
}

YY_PARSE(yycontext *) YYRELEASE(yycontext *yyctx)
{
  if (yyctx->__buflen)
    {
      yyctx->__buflen= 0;
      YY_FREE(yyctx, yyctx->__buf);
      YY_FREE(yyctx, yyctx->__text);
      YY_FREE(yyctx, yyctx->__thunks);
      YY_FREE(yyctx, yyctx->__vals);
    }
  return yyctx;
}

#endif



G_LOCK_DEFINE_STATIC(parse);

GList*
balde_template_parse(const gchar *tmpl)
{
    G_LOCK(parse);
    if_count = 0;
    charbuf = tmpl;
    while(yyparse());
    if (if_count != 0)
        g_error("Syntax error: You left %d open {" "%% if ... %%" "} blocks.", if_count);
    GList *rv = nodes;
    charbuf = NULL;
    nodes = NULL;
    G_UNLOCK(parse);
    return rv;
}

